{- 
   A slight less but still fairly simple chat program in Haskell.
  
  Start this server with port number as command line argument, then connect via telnet.
 -}

module Main where

import System.IO
import Control.Monad(forever)
import System.Environment(getArgs)
import Data.Char(isControl,ord)
import Control.Concurrent
import Network
import System.Posix
import Control.Exception
import System.IO.Error(ioeGetErrorString,isEOFError, catchIOError)

main :: IO ()
main = do
  a:_ <- getArgs
  let p = fromInteger (read a)
  s <- listenOn (PortNumber p)
  ch <- newChan
  loop s ch

loop :: Socket -> Chan String -> IO ()
loop s ch = forever $ do
  (handle, wh, p) <- accept s
  hSetBuffering handle NoBuffering
  installHandler sigPIPE Ignore Nothing
  putStrLn $ "New connection from "++ wh++ 
             " on port "++ show p
  ch2 <- dupChan ch
  forkIO (catchIOError (newUser handle wh ch2)
                       (\e -> hClose handle))

newUser :: Handle-> String-> Chan String -> IO ()
newUser s wh msgch = do
  hPutStrLn s "Hello there. Please send your nickname."
  nick <- do nm <- hGetLine s 
             return (filter (not . isControl) nm)
  hPutStrLn s $ "Nice to meet you, "++ nick++ "!"
  writeChan msgch $ nick++ "@"++ wh++ " has joined."
  wp <- forkIO write
  catchIOError (read ((nick ++ ": ") ++)) $ \e-> do 
    killThread wp
    writeChan msgch $ 
      if isEOFError e then nick++ "@"++ wh++ " has left."
      else nick++ "@"++ wh++ " left hastily ("++ 
                       ioeGetErrorString e++ ")"
    hClose s where
  read :: (String-> String)-> IO ()
  read f = forever $ 
                 hGetLine s >>= writeChan msgch. f
  write :: IO ()
  write = forever $ readChan msgch >>= hPutStrLn s
